<template>
  <div>
    <div class="cardTitle">供应商管理</div>
    <searchForm :formItem="formItem" @getSearch="getData($event)"></searchForm>
    <a-button style="margin: 10px" class="add-btn" @click="drawer.show = true"
      >新增供应商</a-button
    >
    <a-table
      :columns="columns"
      :data-source="tableData"
      :pagination="pagination"
      @change="handleTableChange"
      :row-selection="{
        selectedRowKeys: selectedRowKeys,
        onChange: selectionChoosed,
      }"
      :row-key="
        (record, index) => {
          return record.id;
        }
      "
    >
      <span slot="action" slot-scope="text, row">
        <a-space>
          <a class="ant-dropdown-link" @click="edit(row)">修改</a>
          <a class="ant-dropdown-link" @click="del([row.id])">删除</a>
        </a-space>
      </span>
    </a-table>
    <div class="action">
      <a-dropdown :disabled="!hasSelected">
        <a-menu slot="overlay" @click="handleMenuClick">
          <a-menu-item key="del"> 批量删除 </a-menu-item>
        </a-menu>
        <a-button> 批量操作 <a-icon type="down" /> </a-button>
      </a-dropdown>
      <span style="margin-left: 8px">
        <template v-if="hasSelected">
          {{ `已选择 ${selectedRowKeys.length} 条` }}
        </template>
      </span>
    </div>
    <a-drawer
      :title="drawer.title"
      :width="720"
      :visible="drawer.show"
      :body-style="{ paddingBottom: '80px' }"
      @close="addClose"
    >
      <div class="drawer-content">
        基本信息
        <a-divider></a-divider>
        <a-form-model
          ref="ruleForm"
          :model="form"
          :rules="rules"
          layout="vertical"
        >
          <a-form-model-item prop="vendorName" label="供应商名称">
            <a-input
              v-model="form.vendorName"
              placeholder="请输入供应商名称"
              style="width: 50%"
            ></a-input>
          </a-form-model-item>
        </a-form-model>
      </div>
      <div class="drawer-footer">
        <a-button :style="{ marginRight: '8px' }" @click="addClose">
          关闭
        </a-button>
        <a-button type="primary" @click="submit"> 提交 </a-button>
      </div>
    </a-drawer>
  </div>
</template>

<script>
import {
	vendorList,
	vendorInsert,
	vendorDel,
	vendorUpdate,
} from "@/api/shop/vendor";
import { formItem, columns, pagination } from "./depend/config";
import { form, rules } from "./depend/form.js";
export default {
	data() {
		return {
			drawer: {
				show: false,
				title: "新增供应商"
			},
			tableData: [],
			searchForm: {
				name: undefined,
			},
			formItem,
			columns,
			form,
			rules,
			pagination,
			// 选择的index
			selectedRowKeys: [],
		};
	},
	mounted() {
		this.getData();
	},
	methods: {
		async getData(data) {
			if (data !== undefined) {
				console.log(data);
				this.searchForm = data;
				console.log(this.searchForm);
			}
			let res = await vendorList({
				pageNum: this.pagination.current,
				size: this.pagination.pageSize,
				...this.searchForm,
			});
			this.tableData = res.data.rows;
			this.pagination.total = res.data.total;
			this.selectedRowKeys = [];
		},
		edit(data) {
			this.form.vendorName = data.vendorName
			this.form.id = data.id
			this.drawer.show = true;
			this.drawer.title = '修改供应商';
		},
		del(ids) {
			this.$confirm({
				title: "是否删除",
				// okText:'删除',
				// cancelText:'取消',
				icon: "delete",
				onOk: async () => {
					let res = await vendorDel({ ids: ids });
					if (res.code === 200) {
						this.$message.success(res.msg);
						this.getData();
					} else {
						this.$message.error(res.msg);
					}
				},
			});
		},
		// 选择，获取id
		selectionChoosed(data) {
			this.selectedRowKeys = data;
		},
		// 批量操作
		handleMenuClick(data) {
			console.log(data);
			if (data.key === "del") {
				this.del(this.selectedRowKeys);
			}
		},
		// 跳转
		handleTableChange(pagination) {
			console.log(pagination);
			const pager = { ...this.pagination };
			pager.current = pagination.current;
			pager.pageSize = pagination.pageSize;
			this.pagination = pager;
			this.getData();
		},
		addClose() {
			this.$refs.ruleForm.resetFields();
			this.drawer.show = false;
			this.drawer.title = '新增供应商';
		},
		submit() {
			console.log(this.form);
			this.$refs.ruleForm.validate(async (valid) => {
				if (valid) {
					if (this.form.id === null) {
						let res = await vendorInsert(this.form);
						if (res.code === 200) {
							this.$message.success(res.msg);
							this.addClose();
							this.getData();
						} else {
							this.$message.error(res.msg);
						}
					} else {
						console.log(this.form);
						let res = await vendorUpdate(this.form);
						if (res.code === 200) {
							this.$message.success(res.msg);
							this.addClose();
							this.getData();
						} else {
							this.$message.error(res.msg);
						}
					}
				}
			});
		},
	},
	computed: {
		hasSelected() {
			return this.selectedRowKeys.length > 0;
		},
	},
};
</script>
<style lang="less" scoped>
.table-img {
  width: 40px;
  height: 40px;
}
</style>
